package com.aiotagro.cattletrade.exception;

import cn.dev33.satoken.exception.NotLoginException;
import cn.dev33.satoken.exception.NotPermissionException;
import cn.dev33.satoken.exception.NotRoleException;
import com.aiotagro.common.core.web.domain.AjaxResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 全局异常处理
 */
@RestControllerAdvice
@Slf4j
public class GlobalException {

    // 全局异常拦截（拦截项目中的所有异常）
    @ExceptionHandler
    public AjaxResult handlerException(Exception e, HttpServletRequest request, HttpServletResponse response)
            throws Exception {

        // 不同异常返回不同状态码
        AjaxResult aj = null;
        if (e instanceof NotLoginException) {	// 如果是未登录异常
            NotLoginException ee = (NotLoginException) e;
            aj = new AjaxResult(401, ee.getMessage());
        } else if(e instanceof NotRoleException) {		// 如果是角色异常
            NotRoleException ee = (NotRoleException) e;
            aj = new AjaxResult(402, "无此角色：" + ee.getRole());
        } else if(e instanceof NotPermissionException) {	// 如果是权限异常
            NotPermissionException ee = (NotPermissionException) e;
            aj = new AjaxResult(403, "无此权限：" + ee.getCode());
        } else {	// 普通异常, 输出：500 + 异常信息
            aj = new AjaxResult(500, e.getMessage());
            // 打印堆栈，以供调试
            log.error("异常信息：{}", e.getMessage());
            e.printStackTrace();
        }

        // 返回给前端
        return aj;
    }
}